unit umain;

{$mode objfpc}{$H+}

interface

uses
  Classes, Forms, Controls, Graphics, Dialogs, ExtCtrls, SysUtils, FileUtil,
  BGRABitmap,
  cpuusage;  // added 2025-03-02


type
  { TForm1 }
  TForm1 = class(TForm)
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { private declarations }
    old_cpu_last : double;
    procedure DrawEllipseHello( bmp: TBGRABitmap);
  public
    { public declarations }
  end;

var
  Form1: TForm1;


implementation

uses
  //math,
  BGRABitmapTypes;

{$R *.lfm}


procedure TForm1.DrawEllipseHello( bmp: TBGRABitmap);
var
  //br : TBGRACustomBitmap;
  cpu_last : double;  // added 2025-03-02
begin
  //bmp.Fill( BGRABlack);
  bmp.Fill( $00DA605A);//CSSSkyBlue);
  bmp.CustomPenStyle:= BGRAPenStyle( 2, 1);
  //bmp.FillEllipseLinearColorAntialias( bmp.Width/2,
  //                                     bmp.Height/2,
  //                                     bmp.Width/2-5,
  //                                     bmp.Height/2-5,
  //                                     BGRAPixelTransparent,
  //                                     BGRAWhite);
  //bmp.EllipseAntialias( bmp.Width/2,
  //                      bmp.Height/2,
  //                      bmp.Width/2-5,
  //                      bmp.Height/2-5,
  //                      CSSRed,
  //                      5);
  if bmp.Height div 10 < 10
    then bmp.FontHeight := 10
    else bmp.FontHeight := bmp.Height div 10;

  with bmp.FontPixelMetric do
    begin
      bmp.TextOut( bmp.Width/2,
                   bmp.Height/3 - (CapLine+Baseline)/2,
                   'Hello world',
                   BGRABlack,
                   taCenter);
      bmp.TextOut( bmp.Width/2,
                   bmp.Height/2 - (CapLine+Baseline)/2,
                   'Hello world',
                   BGRAWhite,
                   taCenter);
    end;

  bmp.Canvas.Pen.Color:= clYellow;
  //bmp.Canvas.MoveTo( 0, 0);
  //bmp.Canvas.LineTo( bmp.Width, bmp.Height);
  bmp.Canvas.MoveTo( 0, round( bmp.Height*0.95));
  bmp.Canvas.LineTo( bmp.Width, round( bmp.Height*0.95));

  //br:= bmp.CreateBrushTexture( bsDiagCross, CSSYellow, CSSRed);
  //bmp.FillPieInRect( rect( 10, 10, 100, 100), 0, 3*Pi/2, br);
  //br.Free;

  bmp.TextOutAngle( bmp.Width *0.05, bmp.Height*0.01, -200, 'Test angle', CSSGreen, taLeftJustify);
  bmp.TextOutAngle( bmp.Width *0.6, bmp.Height*0.13, +200, 'Test angle', CSSGreen, taLeftJustify);


  // added 2025-03-02 - show Text in lower right corner
  bmp.FontHeight := bmp.Height div 11;
  bmp.TextOut( bmp.Width *0.98, bmp.Height*0.73, DateToStr( Now), BGRAWhite, taRightJustify);
  bmp.TextOut( bmp.Width *0.98, bmp.Height*0.83, TimeToStr( Now), BGRAWhite, taRightJustify);

  // added 2025-03-02 - GetSystemTimes();
  cpu_last:= get_cpu_last;
  bmp.TextOut( 10, bmp.Height*0.83, 'CPU Usage ' +IntToStr( round( old_cpu_last)) +' %', BGRAWhite, taLeftJustify);
  old_cpu_last:= (49*old_cpu_last +cpu_last) / 50;
end;


{ TForm1 }
procedure TForm1.FormCreate(Sender: TObject);
begin
  Self.Timer1.Enabled:= TRUE;
end;

procedure TForm1.FormPaint(Sender: TObject);
var
  bmp: TBGRABitmap;
begin
  bmp:= TBGRABitmap.Create( ClientWidth, ClientHeight);
  DrawEllipseHello( bmp);
  bmp.Draw( Canvas, 0, 0);
  bmp.Free;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Invalidate;
end;


end.

